#! /usr/bin/env python
#

import os, os.path, popen2, string, threading, time, sys
import Image 
from wxPython.wx import wxMutexGuiEnter, wxMutexGuiLeave, wxImage, wxBITMAP_TYPE_JPEG
from wxPython.wx import wxMessageDialog, wxOK, wxICON_ERROR

class Render(threading.Thread):

	def __init__(self, parent, file, outfile, delete=0):
		threading.Thread.__init__(self)
		self.parent = parent
		self.file = file
		self.delete = delete
		self.outfile = outfile

	def run(self):
		self.parent.rendering = 1
		olddir = os.getcwd()
		os.chdir(os.path.dirname(self.file))
		wxMutexGuiEnter()
		self.parent.output.AppendText('Start render [%s]\n' %(time.strftime('%H:%M:%S')))
		wxMutexGuiLeave()
		starttime=time.time()

		cmd = self.parent.config['render.yafex']+' '+int(self.parent.config['render.netop'])*'-z '
		cmd += '-c %s %s' % (self.parent.config['render.numcpu'], os.path.basename(self.file))

		# This has to be redone, the code is the ugliest I've ever written
		try:
			if os.name == 'posix':
				fo = os.popen(cmd)

				for x in fo:
					#print x
					wxMutexGuiEnter()
					self.parent.output.AppendText(x)
					wxMutexGuiLeave()

			else:
				shello, shelli, shelle = popen2.popen3(cmd)

				for shell in shello.xreadlines():
					#print x
					wxMutexGuiEnter()
					self.parent.output.AppendText(shell)
					wxMutexGuiLeave()

		finally:
			if os.name == 'posix':
				ec = fo.close()
			else:
				ec = shello.close()
				ec2 = shelli.close()
				ec3 = shelle.close()
				sys.stdout.flush()
				
		wxMutexGuiEnter()
		self.parent.output.AppendText('End render  [%s]\n' %(time.strftime('%H:%M:%S')))
		stoptime= time.time()
		elapsed = stoptime - starttime
		ellist=string.split(time.strftime('%j:%H:%M:%S', time.gmtime(elapsed)), ':')
		ellist[0] = '%02i' % (int(ellist[0])-1)
		self.parent.output.AppendText('Duration:  %.3f sec. [%s]\n' % (elapsed, string.join(ellist,':')))
		wxMutexGuiLeave()

		if not ec:
			if self.delete:
				try:
					os.remove(os.path.basename(self.file))
				except:
					wxMutexGuiEnter()
					self.parent.output.AppendText('Couldn\'t remove temporary renderfile'+self.file)
					wxMutexGuiLeave()
			try:
				# Show the rendered picture
				of = os.path.splitext(os.path.basename(self.outfile))[0]+'.jpg'
				rfp = Image.open(self.outfile.encode('ascii')).save(of.encode('ascii'), 'JPEG')
				# print self.parent.preview.GetClientSize()
				wxMutexGuiEnter()
				self.parent.preview.SetBitmap(wxImage(of, wxBITMAP_TYPE_JPEG).ConvertToBitmap())
				wxMutexGuiLeave()
			except:
				wxMutexGuiEnter()
				dlg = wxMessageDialog(self.parent,
									  'An error has occured during rendering!',
									  'ERROR!',
									  wxOK | wxICON_ERROR)
				ok = dlg.ShowModal()
				wxMutexGuiLeave()
		else:
			wxMutexGuiEnter()
			dlg = wxMessageDialog(self.parent,
								  'An error has occured during rendering!',
								  'ERROR!',
								  wxOK | wxICON_ERROR)
			ok = dlg.ShowModal()
			wxMutexGuiLeave()
			
		os.chdir(olddir)
		self.parent.rendering = 0
		
